# -*- coding: utf-8 -*-

from Crypto import Random
from Crypto.PublicKey import RSA
import base64
import sys
import os

def main():
    if len(sys.argv) != 2:
        print("Usage: python3 generate_rsa_key_pair.py DEST_DIR")
        return
    rg = Random.new().read
    rsa = RSA.generate(2048, rg)
    priv_pem = rsa.exportKey()
    with open(os.path.join(sys.argv[1], 'private_key.pem'), 'wb+') as f:
        f.write(priv_pem)
    pub_pem = rsa.publickey().exportKey()
    with open(os.path.join(sys.argv[1], 'public_key.pem'), 'wb+') as f:
        f.write(pub_pem)

if __name__ == '__main__':
    main()