package test

import (
	"bytes"
	"iottid"
	"testing"
)

func TestSM4(t *testing.T) {
	originData := []byte("hello world,bye!hello world,bye!")
	t.Logf("origin data: %v", originData)
	sessionKey := []byte("1234567890abcdef")
	encryptedData, err := iottid.EncryptDataWithSM4(originData, sessionKey)
	if err != nil {
		t.Errorf("SM4 encrypt failed: %s", err)
		return
	}
	t.Logf("encrypted data: %v", encryptedData)
	decryptedData, err := iottid.DecryptDataWithSM4(encryptedData, sessionKey)
	if err != nil {
		t.Errorf("SM4 decrypt failed: %s", err)
		return
	}
	t.Logf("decrypted data: %v", decryptedData)
	if bytes.Compare(originData, decryptedData) != 0 {
		t.Errorf("SM4 data inconsistent")
		return
	}
	t.Logf("SM4 test ok")
}
